--Velocity Buffer Output v2.1
--scripted render-effect
--designed with 2D motion blur post-processes in mind

--(c) April 2005 Alex McLeod, adapted by David Baker


plugin renderEffect velout
name:"Velocity Buffer Output" 
classid:#(0x2bbad6ed, 0x1ec7b9b5)
(   
function cclamp col = (
	col = col as color
	if col.r < 0 then col.r = 0
	if col.g < 0 then col.g = 0
	if col.b < 0 then col.b = 0
	if col.a < 0 then col.a = 0
	if col.r > 255 then col.r = 255
	if col.g > 255 then col.g = 255
	if col.b > 255 then col.b = 255
	if col.a > 255 then col.a = 255
	col
	)

parameters main rollout:params (
	normalise type:#integer default:7 ui:normalspin
	)
rollout params "Velocity Output Parameters" (
	label lab1 "The Normalise value translates to the"
	label lab2 "MaxDisplace value in ReelSmart Motion Blur from"
	hyperlink hyper1 "RE:Vision Effects, Inc." address:"http://www.revisionfx.com/" align:#center
	label lab3 "4 -->256, 5 --> 512, 6 --> 1024, 7 --> 2048"
	spinner normalspin "Normalise: " type:#integer range:[4,7,normalise] fieldwidth:24 align:#right
	)
	
on channelsrequired do #(#velocity, #coverage)
on apply img do (
	c_img = getchannelasmask img #coverage
	case normalise of
	(
		4: mr_norm = 2
		5: mr_norm = 4
		6: mr_norm = 8
		7: mr_norm = 16
	)
	for y = 0 to (img.height-1) do (
		local irow = getpixels c_img [0,y] img.width
		local row = for x = 1 to (img.width) collect (
			if irow[x].r > 0 then (
				q = x-1
				vel = ((getchannel img [q,y] #velocity)[1])/mr_norm
				cclamp (color (127.0 - vel.x) (127.0 + vel.y) 0 255)
				) else (color 0 0 0 0)
			)
		setpixels img [0,y] row
		)
	)
)